const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const subscriptions = sequelize.define(
    'subscriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

provider_reference: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"trialing",


"active",


"past_due",


"canceled",


"unpaid",


"paused"

        ],

      },

current_period_start_at: {
        type: DataTypes.DATE,
      
      

      },

current_period_end_at: {
        type: DataTypes.DATE,
      
      

      },

cancelled_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subscriptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.subscriptions.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.customers, {
      as: 'customer',
      foreignKey: {
        name: 'customerId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.service_packages, {
      as: 'service_package',
      foreignKey: {
        name: 'service_packageId',
      },
      constraints: false,
    });




    db.subscriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subscriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return subscriptions;
};


